config/routes.rb
Rails.application.routes.draw do
  root "tasks#index"
  
  resources :tasks do
    put :test
    get :edit_content
    delete :erase_finished
  end
  

end

app/models/task.rb
class Task < ActiveRecord::Base
end

app/controllers/application_controller.rb
class ApplicationController < ActionController::Base
  # Prevent CSRF attacks by raising an exception.
  # For APIs, you may want to use :null_session instead.
  protect_from_forgery with: :exception
end

app/controllers/tasks_controller.rb
class TasksController < ApplicationController
  before_action :set_task, only: [:show, :edit, :update, :destroy]
  
  # GET /tasks
  # GET /tasks.json
  def index
    @tasks = Task.all
    if !params[:test]
      @ind = 1
    else
      @ind = 2
      respond_to do |format|
        format.html { redirect_to @task }
        format.js
      end
    end
  end

  # GET /tasks/1
  # GET /tasks/1.json
  def show
  end

  # GET /tasks/new
  def new
    @task = Task.new
  end

  # GET /tasks/1/edit
  def edit
  end

  # POST /tasks
  # POST /tasks.json
  def create
    @task = Task.new(task_params)
    @task.save
    respond_to do |format|
        format.html { redirect_to @task, notice: 'Task was successfully created.' }
        format.js
    end
  end

  # PATCH/PUT /tasks/1
  # PATCH/PUT /tasks/1.json
  def update
    respond_to do |format|
      if @task.update(task_params)
        format.html { redirect_to @task, notice: 'Task was successfully updated.' }
        format.json { render :show, status: :ok, location: @task }
      else
        format.html { render :edit }
        format.json { render json: @task.errors, status: :unprocessable_entity }
      end
    end
  end

  # DELETE /tasks/1
  # DELETE /tasks/1.json
  def destroy
    @task.destroy
    respond_to do |format|
      format.js
    end
  end
  
  def test
    @task = Task.find(params[:task_id])
    @task.update(:status => !@task.status)
    respond_to do |format|
      format.js
    end
  end
  
  def edit_content
    @flagedit=1
    @task = Task.find(params[:task_id])
    respond_to do |format|
      format.js
    end
  end
  
  def erase_finished
    respond_to do |format|
    format.js
  end
  end
  
  private
    # Use callbacks to share common setup or constraints between actions.
    def set_task
      @task = Task.find(params[:id])
    end

    # Never trust parameters from the scary internet, only allow the white list through.
    def task_params
      params.require(:task).permit(:content, :status)
    end
end

app/helpers/application_helper.rb
module ApplicationHelper
end

app/helpers/tasks_helper.rb
module TasksHelper
end

app/views/layouts/application.html.erb
<!DOCTYPE html>
<html>
  <head>
    <title>ToDoList</title>
    <link href='http://fonts.googleapis.com/css?family=Ubuntu' rel='stylesheet' type='text/css'>
    <link href='http://fonts.googleapis.com/css?family=Covered+By+Your+Grace' rel='stylesheet' type='text/css'>
    <link href='http://fonts.googleapis.com/css?family=Condiment' rel='stylesheet' type='text/css'>
    <link href='http://fonts.googleapis.com/css?family=Shadows+Into+Light' rel='stylesheet' type='text/css'>
    <%= stylesheet_link_tag    'application', media: 'all', 'data-turbolinks-track' => true %>
    <%= javascript_include_tag 'application', 'data-turbolinks-track' => true %>
    <%= csrf_meta_tags %>
  </head>
  <body>
    <div id="cont" style="height:100vh;width:100vw;margin:0;">
      <img id="bckg" src="http://www.jefreygdesigns.com/cinema-display/red-pattern.jpg">
      <div class="header" >
        <div class="Links">
          <div class="NewTaskLink"><%= link_to (image_tag 'add.png', class: "add-icon"), new_task_path, id: "new_link", remote: true %></div>
          <div class="NewTaskLink"><%= link_to (image_tag 'cancel2.png', id: "cancel-icon"), '#', id: "new_link_cancel", style: "display:none" %></div>
          <div class="Finished"><%= link_to (image_tag 'check.png', id: "show-f"), root_path(:test => 3), remote: true %></div>
        </div>
        <div id='task-form' style="display:none;"></div>
        <div id='rest'><%= render('rest') %></div>
        <div id="hinner">
          <p>To-do list</p>
        </div>
      </div>
      
      <div class="Main-container">
        <%= yield %>
      </div>
      <div class="trash"><%= image_tag("drop.png", style: "opacity:0.5") %></div>
      <div class="trash" id="tr" style="<% if Task.where(status: true).count == 0 %>display:none<% else %>initial<% end %>"><%= link_to (image_tag 'filtrash.png'), task_erase_finished_path(:task_id => -1), remote: true, method: :delete, class: "trash-link", data: { confirm: "Do you realy want to erase ALL the FINISHED tasks ?" } %></div>
     <div class="cprt"><p>Nathan gouy @ngouy</p></div>
    </div>
  </body>
</html>

app/views/tasks/_form.html.erb
<%= form_for @task, remote: true do |f| %>
  <div class="field">
    <%= f.label :content, "What is to do ?", id: "title-new" %><br>
    <%= f.text_area :content %>
  </div>
  <div class="field" style="display:none;">
    <%= f.label :status %><br>
    <%= f.check_box :status %>
  </div>
  <div class="actions" id="sub-new">
    <%= f.submit %>
  </div>
<% end %>

app/views/tasks/_rest.html.erb
<% if Task.all.count == 0 %>
    Nothing to do... For now
<% elsif Task.where(status: false).count == 0 %>
    Nothing left!<br><br><br>Let's take a cofee-break.
<% elsif Task.where(status: false).count == 1 %>
    <span id='nb-left'>1</span><br><br><br>thing to do. Almost there!
<% else %>
    <span id='nb-left'><%= Task.where(status: false).count %></span><br><br><br>things to do 
    <% if Task.all.count ==  Task.where(status: false).count %>
        ( all in fact ...).
    <% else %>. Keep going!
    <% end %>
<% end %>

app/views/tasks/_task.html.erb
<% if task.status %>
    <% @img = "check3.png" %>
<% else %>
    <% @img = "check2.png" %>
<% end %>
<div id="edited_task_<%= task.id %>" class="all_task">
    <div class="un-done-div"><%= link_to (image_tag @img, class: "un-done"), task_test_path(task), remote: true, class: "un-done-link", method: :put %></div>
    <div class="content-div">
        <%= link_to task_edit_content_path(task), remote: true do %>
            <p class="task-content" style="
            text-decoration:<% if task.status%>line-through<% else %>none<% end %>;
            opacity:<% if task.status%>0.5<% else %>1<% end %>;">
                <%= task.content %></p>
        <% end %>
        <p class="change_content" style="display:none"></p>
    </div>
    <div class="trash-div">
        <% if !task.status%>
            <%= link_to (image_tag 'drop.png', class: "drop", style: "opacity:0.5"), task, remote: true, method: :delete, class: "trash-link", data: { confirm: "Sure to drop the task \"" + task.content + "\" ?" } %>
        <% else %>
            <%= link_to (image_tag 'drop.png', class: "drop", style: "opacity:1"), task, remote: true, method: :delete, class: "trash-link", data: { confirm: "Sure to drop the task \"" + task.content + "\" ?" } %>
        <% end %>
    </div>
    
</div>

app/views/tasks/cancel_new.js.erb
$('#new_link_cancel').slideUp(350);
$('#new_link').delay(400).slideDown(350);
$('#task-form').slideUp(350);

app/views/tasks/create.js.erb
$('#new_task').slideUp(350);
$('#new_link').slideDown(350);
$('#new_link_cancel').slideUp(350);
$('#task-form').slideUp(450);
$('#tasks_list').append( '<%= j render(@task) %>');
$('#edited_task_<%= @task.id %>').css("display","none");
$('#edited_task_<%= @task.id %>').slideDown(350);
$('#rest').fadeOut(350);
    $('#rest').delay(0).queue(function(n) {
        $(this).html( "<%= j render("rest") %> ");
        n();
    });
     $('#rest').fadeIn(350);

app/views/tasks/destroy.js.erb
$('#edited_task_<%= @task.id %>').slideUp(350);
$('#edited_task_<%= @task.id %>').queue(function(n) {
    $(this).remove();
    n();
});
$('#rest').html( "<%= j render("rest") %> ");
<% if Task.where(status: true).count == 0 %>
    $('#tr').fadeOut(350);
<% else %>
    $('#tr').fadeIn(350);
<% end %>

app/views/tasks/edit_content.js.erb
$('#edited_task_<%= @task.id %> .content-div a').slideUp(350);
$('#edited_task_<%= @task.id %> .content-div .change_content').html( "<%= j render("update_content") %> ").fadeIn(350);

app/views/tasks/erase_finished.js.erb
<%
@toer=Task.where(status: true)
@toer.each do |t| %>
  $('#edited_task_<%= t.id %>').slideUp(350).delay(350).queue(function(n) {
      $(this).remove();
      n();
  });
  <%
    t.destroy
  end
%>
    
$('#tr').fadeOut(350);
$('#rest').fadeOut(350);
$('#rest').delay(0).queue(function(n) {
    $(this).html( "<%= j render("rest") %> ");
    n();
});
$('#rest').fadeIn(350);

app/views/tasks/index.html.erb
<div id="tasks_list">
  <% @tasks.each do |task| %>
  <%= render task %>
  <% end %>
</div>

app/views/tasks/index.js.erb
<% if @ind >= 2 %>
    <% @tasks.each do |t| %>
        <% if t.status %>
                if  ($('#edited_task_<%= t.id %>').css('display') == 'none')
                    $('#edited_task_<%= t.id %>').slideDown(350);
                else
                    $('#edited_task_<%= t.id %>').slideUp(350);
        <%end%>
    <%end%>
<%end%>

app/views/tasks/new.js.erb
$('#new_link').slideUp(350);
$('#task-form').html('<%= j render("form") %>');
$('#task-form').slideDown(350);
$('#new_link_cancel').fadeIn(550);

app/views/tasks/show.js.erb
$('#edited_task_<%= @task.id %>').slideDown(350).replaceWith( "<%= j render(@task) %> ");

app/views/tasks/test.js.erb
$('#edited_task_<%= @task.id %>').replaceWith( "<%= j render(@task) %> ");
$('#rest').fadeOut(350);
$('#rest').delay(0).queue(function(n) {
    $(this).html( "<%= j render("rest") %> ");
    n();
});
$('#rest').fadeIn(350);
<% if Task.where(status: true).count == 0 %>
    $('#tr').fadeOut(350);
<% else %>
    $('#tr').fadeIn(350);
<% end %>